<?php

namespace \Tests\Unit\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 Stefan Frömken <froemken@gmail.com>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class \SF\Sfcombination\Domain\Model\CarFeatureMm.
 *
 * @version $Id$
 * @copyright Copyright belongs to the respective authors
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 * @author Stefan Frömken <froemken@gmail.com>
 */
class CarFeatureMmTest extends \TYPO3\CMS\Extbase\Tests\Unit\BaseTestCase {
	/**
	 * @var \SF\Sfcombination\Domain\Model\CarFeatureMm
	 */
	protected $subject;

	public function setUp() {
		$this->subject = new \SF\Sfcombination\Domain\Model\CarFeatureMm();
	}

	public function tearDown() {
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function getCarReturnsInitialValueForCar() {
		$this->assertEquals(
			NULL,
			$this->subject->getCar()
		);
	}

	/**
	 * @test
	 */
	public function setCarForCarSetsCar() {
		$carFixture = new \SF\Sfcombination\Domain\Model\Car();
		$this->subject->setCar($carFixture);

		$this->assertAttributeEquals(
			$carFixture,
			'car',
			$this->subject
		);
	}

	/**
	 * @test
	 */
	public function getFeatureReturnsInitialValueForFeature() {
		$this->assertEquals(
			NULL,
			$this->subject->getFeature()
		);
	}

	/**
	 * @test
	 */
	public function setFeatureForFeatureSetsFeature() {
		$featureFixture = new \SF\Sfcombination\Domain\Model\Feature();
		$this->subject->setFeature($featureFixture);

		$this->assertAttributeEquals(
			$featureFixture,
			'feature',
			$this->subject
		);
	}
}
